// Sterowanie diodami RGB za pomocą smartfonu 
// Autor: Patryk Mądry 
// http://mikrokontroler.pl


#include <Adafruit_NeoPixel.h> // Biblioteka do sterowania diodami
#define PIN            6       // Pin do sterowania diodami ws2812
#define NUMPIXELS      16      // Ilosc diod ws2812 w pierscieniu

Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800); 

void setup() 
{
  
  Serial.begin(38400); // Prędkość transmisji moddulu Bluettoth
  pixels.begin(); // Uruchomienie dzialania biblioteki Adafruit_NeoPixel
  
}
// Zmienne programu 
char OdebraneDane[20]; 
byte indeks;
int Dioda_R = 0;  // wartosc jasnosci dla diod czerwonych 
int Dioda_G = 0;  // wartosc jasnosci dla diod zielonych
int Dioda_B = 0;  // wartosc jasnosci dla diod niebieskich 
char znak ="";


void zapal_diody()
{
    for(int i=0;i<NUMPIXELS;i++)
   {
      pixels.setPixelColor(i, pixels.Color(Dioda_R,Dioda_G,Dioda_B)); // Ustawienie kolorów dla poszczegolnych barw 
      pixels.show(); 
   }
  
}

void Odbierz_Dane() // Dekodowanie ramki 
{
  
  if (OdebraneDane[0] == 'R') 
  {
     Dioda_R = atoi(OdebraneDane + 2);
  }
  else if (OdebraneDane[0] == 'G') 
  {
     Dioda_G = atoi(OdebraneDane + 2);
  }
  else if (OdebraneDane[0] == 'B') 
  {
     Dioda_B = atoi(OdebraneDane + 2);
  }
}



void loop() 
{

   if (Serial.available() > 0  ) //
  {
   
   delay(50);
   
   do{
   
    znak = (char)Serial.read();
   OdebraneDane[indeks] = znak;
   indeks++;

   } while(znak != '\n');
   
   OdebraneDane[indeks] = 0;
   indeks=0;
   
   
      Odbierz_Dane();
       zapal_diody();
  }
  
}

  

  



